/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "parser.y"

/*
 * Copyright (c) 2004-2005 Endace Technology Ltd, Hamilton, New Zealand.
 * All rights reserved.
 *
 * This source code is proprietary to Endace Technology Limited and no part
 * of it may be redistributed, published or disclosed except as outlined in
 * the written contract supplied with this product.
 *
 * $Id: parser.y 12691 2010-04-01 02:13:24Z wilson.zhu $
 */

#define YYSTYPE long

/* Parser headers. */
#include "filter_rule_types.h"
#include "rule_lib.h"
#include "parser.h"
#include "utilities.h"

/* Endace headers. */
#include "dagutil.h"


/* CVS header. */
static const char * const kParserCvsHeader __attribute__ ((unused)) = "$Id: parser.y 12691 2010-04-01 02:13:24Z wilson.zhu $";

#define VERBOSE 1


static filter_rule_t* uRule = NULL;
static uint8_t uAction;
static uint8_t uProtocol;
static int uBidirectional;
static list_node_t* uSourceAddress;
static int uSourceNegated;
static ipf_port_t* uSourcePort;
static list_node_t* uDestinationAddress;
static int uDestinationNegated;
static ipf_port_t* uDestinationPort;
static int uNegation;

static FILE* uLogfile = NULL;

/* Declarations for routines generated by the flex scanner. */
extern void yy_scan_string(const char *str);
extern int yylex(void);

void yyerror(const char* error_msg);
//int yyparse(void);

void note_construction(const char* comment);
void note_progress(const char* comment);
void note_rule(filter_rule_t* rule);
void note_port(ipf_port_t* port);
void note_ip_address(ip_address_t* address);
void note_ip_address_list(list_node_t* node);
void note_number(int number);
const char* get_token_string(void);
int get_token_number(void);



/* Line 268 of yacc.c  */
#line 135 "parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACTION_ACCEPT = 258,
     ACTION_REJECT = 259,
     PROTOCOL_ICMP = 260,
     PROTOCOL_IP = 261,
     PROTOCOL_TCP = 262,
     PROTOCOL_UDP = 263,
     UNIDIRECTIONAL = 264,
     BIDIRECTIONAL = 265,
     TOKEN_ANY = 266,
     TOKEN_BODY = 267,
     TOKEN_COLON = 268,
     TOKEN_COMMA = 269,
     TOKEN_COMMENT = 270,
     TOKEN_DOLLAR = 271,
     TOKEN_ERROR = 272,
     TOKEN_FORWARD_SLASH = 273,
     TOKEN_HOSTNAME = 274,
     TOKEN_LEFT_SQUARE = 275,
     TOKEN_NEGATE = 276,
     TOKEN_NUMBER = 277,
     TOKEN_PERIOD = 278,
     TOKEN_RIGHT_SQUARE = 279,
     TOKEN_VAR = 280,
     TOKEN_VARIABLE = 281
   };
#endif
/* Tokens.  */
#define ACTION_ACCEPT 258
#define ACTION_REJECT 259
#define PROTOCOL_ICMP 260
#define PROTOCOL_IP 261
#define PROTOCOL_TCP 262
#define PROTOCOL_UDP 263
#define UNIDIRECTIONAL 264
#define BIDIRECTIONAL 265
#define TOKEN_ANY 266
#define TOKEN_BODY 267
#define TOKEN_COLON 268
#define TOKEN_COMMA 269
#define TOKEN_COMMENT 270
#define TOKEN_DOLLAR 271
#define TOKEN_ERROR 272
#define TOKEN_FORWARD_SLASH 273
#define TOKEN_HOSTNAME 274
#define TOKEN_LEFT_SQUARE 275
#define TOKEN_NEGATE 276
#define TOKEN_NUMBER 277
#define TOKEN_PERIOD 278
#define TOKEN_RIGHT_SQUARE 279
#define TOKEN_VAR 280
#define TOKEN_VARIABLE 281




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 229 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  13
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   58

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  27
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  21
/* YYNRULES -- Number of rules.  */
#define YYNRULES  48
/* YYNRULES -- Number of states.  */
#define YYNSTATES  69

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   281

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     4,     6,     8,    10,    12,    14,    19,
      25,    29,    34,    38,    43,    50,    52,    54,    56,    58,
      60,    62,    65,    67,    69,    72,    74,    78,    81,    83,
      85,    88,    90,    94,    96,    98,   102,   104,   106,   109,
     111,   113,   116,   120,   123,   126,   128,   130,   132
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      28,     0,    -1,    -1,    17,    -1,    29,    -1,    30,    -1,
      31,    -1,    15,    -1,    25,    46,    16,    26,    -1,    25,
      46,    21,    16,    26,    -1,    25,    46,    37,    -1,    25,
      46,    21,    37,    -1,    25,    46,    42,    -1,    25,    46,
      21,    42,    -1,    32,    33,    34,    35,    36,    47,    -1,
       3,    -1,     4,    -1,     5,    -1,     6,    -1,     7,    -1,
       8,    -1,    38,    43,    -1,    10,    -1,     9,    -1,    38,
      43,    -1,    40,    -1,    20,    39,    24,    -1,    16,    46,
      -1,    37,    -1,    11,    -1,    21,    38,    -1,    40,    -1,
      40,    14,    39,    -1,    19,    -1,    41,    -1,    19,    18,
      22,    -1,    45,    -1,    44,    -1,    16,    46,    -1,    42,
      -1,    11,    -1,    21,    43,    -1,    45,    13,    45,    -1,
      13,    45,    -1,    45,    13,    -1,    22,    -1,    26,    -1,
      12,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   100,   100,   101,   106,   107,   108,   111,   123,   173,
     221,   231,   249,   259,   273,   309,   310,   313,   314,   315,
     316,   319,   332,   333,   336,   349,   356,   365,   392,   399,
     411,   422,   429,   444,   461,   470,   512,   525,   532,   556,
     563,   575,   587,   600,   612,   626,   634,   644,   652
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACTION_ACCEPT", "ACTION_REJECT",
  "PROTOCOL_ICMP", "PROTOCOL_IP", "PROTOCOL_TCP", "PROTOCOL_UDP",
  "UNIDIRECTIONAL", "BIDIRECTIONAL", "TOKEN_ANY", "TOKEN_BODY",
  "TOKEN_COLON", "TOKEN_COMMA", "TOKEN_COMMENT", "TOKEN_DOLLAR",
  "TOKEN_ERROR", "TOKEN_FORWARD_SLASH", "TOKEN_HOSTNAME",
  "TOKEN_LEFT_SQUARE", "TOKEN_NEGATE", "TOKEN_NUMBER", "TOKEN_PERIOD",
  "TOKEN_RIGHT_SQUARE", "TOKEN_VAR", "TOKEN_VARIABLE", "$accept", "line",
  "comment_line", "variable_declaration", "rule_line", "action",
  "protocol", "source", "direction", "destination", "definite_ip_spec",
  "ip_spec", "ip_set", "ip_address", "network", "definite_port_spec",
  "port_spec", "port_range", "single_port", "variable", "body", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    27,    28,    28,    28,    28,    28,    29,    30,    30,
      30,    30,    30,    30,    31,    32,    32,    33,    33,    33,
      33,    34,    35,    35,    36,    37,    37,    38,    38,    38,
      38,    39,    39,    40,    40,    41,    42,    42,    43,    43,
      43,    43,    44,    44,    44,    45,    46,    47,    47
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     1,     1,     1,     1,     4,     5,
       3,     4,     3,     4,     6,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     2,     1,     3,     2,     1,     1,
       2,     1,     3,     1,     1,     3,     1,     1,     2,     1,
       1,     2,     3,     2,     2,     1,     1,     1,     0
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    15,    16,     7,     3,     0,     0,     4,     5,     6,
       0,    46,     0,     1,    17,    18,    19,    20,     0,     0,
       0,    33,     0,     0,    45,    10,    25,    34,    12,    37,
      36,    29,     0,     0,     0,    28,     0,    43,     8,     0,
       0,    31,     0,    11,    13,    44,    27,    30,    23,    22,
       0,    40,     0,     0,    39,    21,    35,    26,     0,     9,
      42,    48,     0,    38,    41,    32,    47,    14,    24
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     6,     7,     8,     9,    10,    18,    34,    50,    61,
      35,    36,    40,    26,    27,    54,    55,    29,    30,    12,
      67
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -43
static const yytype_int8 yypact[] =
{
      -1,   -43,   -43,   -43,   -43,   -20,     8,   -43,   -43,   -43,
      49,   -43,    21,   -43,   -43,   -43,   -43,   -43,    12,   -12,
     -13,     4,    10,    31,   -43,   -43,   -43,   -43,   -43,   -43,
      22,   -43,   -20,    12,    29,   -43,    -4,   -43,   -43,    23,
      24,    32,    26,   -43,   -43,   -12,   -43,   -43,   -43,   -43,
      12,   -43,   -20,    -4,   -43,   -43,   -43,   -43,    10,   -43,
     -43,    37,    -4,   -43,   -43,   -43,   -43,   -43,   -43
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,
       3,   -29,     0,   -22,   -43,     7,   -42,   -43,   -18,   -27,
     -43
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      41,    37,     1,     2,    47,    46,    11,    51,    13,    19,
      24,    64,    52,    38,     3,    25,     4,    53,    24,    28,
      68,    62,    39,    31,     5,    63,    43,    60,    32,    21,
      44,    21,    22,    33,    19,    45,    41,    20,    48,    49,
      21,    22,    23,    24,    19,    56,    58,    42,    57,    66,
      21,    22,    59,    24,    14,    15,    16,    17,    65
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-43))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_uint8 yycheck[] =
{
      22,    19,     3,     4,    33,    32,    26,    11,     0,    13,
      22,    53,    16,    26,    15,    12,    17,    21,    22,    12,
      62,    50,    18,    11,    25,    52,    23,    45,    16,    19,
      23,    19,    20,    21,    13,    13,    58,    16,     9,    10,
      19,    20,    21,    22,    13,    22,    14,    16,    24,    12,
      19,    20,    26,    22,     5,     6,     7,     8,    58
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,    15,    17,    25,    28,    29,    30,    31,
      32,    26,    46,     0,     5,     6,     7,     8,    33,    13,
      16,    19,    20,    21,    22,    37,    40,    41,    42,    44,
      45,    11,    16,    21,    34,    37,    38,    45,    26,    18,
      39,    40,    16,    37,    42,    13,    46,    38,     9,    10,
      35,    11,    16,    21,    42,    43,    22,    24,    14,    26,
      45,    36,    38,    46,    43,    39,    12,    47,    43
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1806 of yacc.c  */
#line 102 "parser.y"
    {
			fprintf(stderr, "%s\n", get_token_string());
			exit(EXIT_FAILURE);
		}
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 112 "parser.y"
    {
			const char* comment = get_token_string();

			note_construction("comment_line: TOKEN_COMMENT\n");
			note_progress(comment);
			note_progress("\n");

			free((char*) comment);
		}
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 124 "parser.y"
    { 
			const char* existing_var = get_token_string();
			variable_t* address_var = get_address_variable(existing_var);
			variable_t* port_var = get_port_variable(existing_var);

			note_construction("variable_declaration: TOKEN_VAR variable TOKEN_DOLLAR TOKEN_VARIABLE\n");
			note_progress((const char*) (yyvsp[(2) - (4)]));
			note_progress("\n");
			note_progress(existing_var);
			note_progress("\n");
			
			if (address_var)
			{
				variable_t* new_var;

				note_ip_address_list(address_var->addr_list);
				
				/* add_address_variable() owns the string after this call. */
				add_address_variable((const char*) (yyvsp[(2) - (4)]), address_var->addr_list); 

				new_var = get_address_variable((const char*) (yyvsp[(2) - (4)]));

				assert(new_var);

				new_var->inverse = address_var->inverse;
			}
			else if (port_var)
			{
				variable_t* new_var;

				note_port(&port_var->ports);
				
				/* add_port_variable() owns the string after this call. */
				add_port_variable((const char*) (yyvsp[(2) - (4)]), &port_var->ports); 

				new_var = get_port_variable((const char*) (yyvsp[(2) - (4)]));

				assert(new_var);

				new_var->inverse = address_var->inverse;
			}
			else
			{
				fprintf(stderr, "could not find variable %s\n", existing_var);
				exit(EXIT_FAILURE);
			}

			free((char*) existing_var);
		}
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 174 "parser.y"
    { 
			const char* existing_var = get_token_string();
			variable_t* address_var = get_address_variable(existing_var);
			variable_t* port_var = get_port_variable(existing_var);

			note_construction("variable_declaration: VAR variable TOKEN_NEGATE TOKEN_DOLLAR TOKEN_VARIABLE\n");
			note_progress((const char*) (yyvsp[(2) - (5)]));
			note_progress("\n");
			note_progress(existing_var);
			note_progress("\n");
			
			if (address_var)
			{
				variable_t* new_var;

				note_ip_address_list(address_var->addr_list);
				
				/* add_address_variable() owns the string after this call. */
				add_address_variable((const char*) (yyvsp[(2) - (5)]), address_var->addr_list); 

				/* Negate the variable. */
				new_var = get_address_variable((const char*) (yyvsp[(2) - (5)]));
				assert(new_var);
				new_var->inverse = !(address_var->inverse);
			}
			else if (port_var)
			{
				variable_t* new_var;

				note_port(&port_var->ports);
				
				/* add_port_variable() owns the string after this call. */
				add_port_variable((const char*) (yyvsp[(2) - (5)]), &port_var->ports); 

				/* Negate the variable. */
				new_var = get_port_variable((const char*) (yyvsp[(2) - (5)]));
				assert(new_var);
				new_var->ports.inverse = !(port_var->ports.inverse);
			}
			else
			{
				fprintf(stderr, "could not find variable %s\n", existing_var);
				exit(EXIT_FAILURE);
			}

			free((char*) existing_var);
		}
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 222 "parser.y"
    { 
			note_construction("variable_declaration: TOKEN_VAR variable ip_spec\n");
			note_progress((const char*) (yyvsp[(2) - (3)]));
			note_progress("\n");
			note_ip_address_list((list_node_t*) (yyvsp[(3) - (3)]));

			/* add_address_variable() owns the string after this call. */
			add_address_variable((const char*) (yyvsp[(2) - (3)]), (list_node_t*) (yyvsp[(3) - (3)])); 
		}
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 232 "parser.y"
    { 
			variable_t* address_var = NULL;

			note_construction("variable_declaration: TOKEN_VAR variable TOKEN_NEGATE ip_spec\n");
			note_progress((const char*) (yyvsp[(2) - (4)]));
			note_progress("\n");
			note_ip_address_list((list_node_t*) (yyvsp[(3) - (4)]));

			/* add_address_variable() owns the string after this call. */
			add_address_variable((const char*) (yyvsp[(2) - (4)]), (list_node_t*) (yyvsp[(3) - (4)])); 

			/* Negate the address list. */
			address_var = get_address_variable((const char*) (yyvsp[(2) - (4)])); 

			assert(address_var);
			address_var->inverse = 1;
		}
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 250 "parser.y"
    { 
			note_construction("variable_declaration: TOKEN_VAR variable port_spec\n");
			note_progress((const char*) (yyvsp[(2) - (3)]));
			note_progress("\n");
			note_port((ipf_port_t*) (yyvsp[(3) - (3)]));

			/* port_variable() owns the string after this call. */
			add_port_variable((const char*) (yyvsp[(2) - (3)]), (ipf_port_t*) (yyvsp[(3) - (3)])); 
		}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 260 "parser.y"
    { 
			note_construction("variable_declaration: TOKEN_VAR variable TOKEN_NEGATE port_spec\n");
			note_progress((const char*) (yyvsp[(2) - (4)]));
			note_progress("\n");
			note_port((ipf_port_t*) (yyvsp[(3) - (4)]));

			((ipf_port_t*) (yyvsp[(3) - (4)]))->inverse = 1;

			/* port_variable() owns the string after this call. */
			add_port_variable((const char*) (yyvsp[(2) - (4)]), (ipf_port_t*) (yyvsp[(3) - (4)])); 
		}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 274 "parser.y"
    { 
			note_construction("rule_line: action protocol source direction destination body\n");

			/* Build rule structure from the results of the parse. */
			uRule = (filter_rule_t*) malloc(sizeof(filter_rule_t));

			if (uRule)
			{
				memset(uRule, 0, sizeof(filter_rule_t));
				uRule->action = uAction;
				uRule->protocol.protocol = uProtocol;
				uRule->protocol.mask = 0xff;
				uRule->source = uSourceAddress;
				uRule->src_inverse = uSourceNegated;
				uRule->dest = uDestinationAddress;
				uRule->dest_inverse = uDestinationNegated;
				uRule->bidirectional = uBidirectional;
				memcpy(&uRule->src_port, uSourcePort, sizeof(ipf_port_t));
				memcpy(&uRule->dest_port, uDestinationPort, sizeof(ipf_port_t));
			}

			if (uSourcePort)
			{
				dispose_port(uSourcePort);
			}
	
			if (uDestinationPort)
			{
				dispose_port(uDestinationPort);
			}

			note_rule(uRule);
		}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 309 "parser.y"
    { uAction = ACCEPT; note_construction("action: ACCEPT\n"); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 310 "parser.y"
    { uAction = REJECT; note_construction("action: REJECT\n"); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 313 "parser.y"
    { uProtocol = IPPROTO_ICMP; note_construction("protocol: ICMP\n"); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 314 "parser.y"
    { uProtocol = IPPROTO_IP; note_construction("protocol: IP\n"); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 315 "parser.y"
    { uProtocol = IPPROTO_TCP; note_construction("protocol: TCP\n"); }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 316 "parser.y"
    { uProtocol = IPPROTO_UDP; note_construction("protocol: UDP\n"); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 320 "parser.y"
    { 
			note_construction("source:\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (2)]));
			note_port((ipf_port_t*) (yyvsp[(2) - (2)]));

			uSourceAddress = (list_node_t*) (yyvsp[(1) - (2)]); 
			uSourcePort = (ipf_port_t*) (yyvsp[(2) - (2)]); 
			uSourceNegated = uNegation;
			uNegation = 0;
		}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 332 "parser.y"
    { uBidirectional = 1; note_construction("direction: bidirectional\n"); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 333 "parser.y"
    { uBidirectional = 0; note_construction("direction: unidirectional\n"); }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 337 "parser.y"
    { 
			note_construction("destination:\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (2)]));
			note_port((ipf_port_t*) (yyvsp[(2) - (2)]));

			uDestinationAddress = (list_node_t*) (yyvsp[(1) - (2)]); 
			uDestinationPort = (ipf_port_t*) (yyvsp[(2) - (2)]); 
			uDestinationNegated = uNegation;
			uNegation = 0;
		}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 350 "parser.y"
    {
			note_construction("definite_ip_spec: ip_address\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (1)]));

			(yyval) = (YYSTYPE) (yyvsp[(1) - (1)]);
		}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 357 "parser.y"
    {
			note_construction("definite_ip_spec: TOKEN_LEFT_SQUARE ip_set TOKEN_RIGHT_SQUARE\n");
			note_ip_address_list((list_node_t*) (yyvsp[(2) - (3)]));

			(yyval) = (YYSTYPE) (yyvsp[(2) - (3)]);
		}
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 366 "parser.y"
    {
			variable_t* address_var = get_address_variable((const char*) (yyvsp[(2) - (2)]));

			note_construction("ip_spec: TOKEN_DOLLAR variable\n");
			note_progress((const char*) (yyvsp[(2) - (2)]));
			note_progress("\n");

			if (address_var)
			{
				list_node_t* node = clone_address_list(address_var->addr_list);
				
				if (address_var->inverse)
				{
					uNegation = !uNegation;
				}

				(yyval) = (YYSTYPE) (void*) node;
			}
			else
			{
				fprintf(stderr, "error: could not find address variable: %s\n", (const char*) (yyvsp[(2) - (2)]));
				exit(EXIT_FAILURE);
			}

			free((char*) (yyvsp[(2) - (2)]));
		}
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 393 "parser.y"
    {
			note_construction("ip_spec: definite_ip_spec\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (1)]));

			(yyval) = (YYSTYPE) (yyvsp[(1) - (1)]);
		}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 400 "parser.y"
    {
			ip_address_t* address = (ip_address_t*) malloc(sizeof(ip_address_t));
			list_node_t* node = new_list_node(address, NULL);

			memset(address, 0, sizeof(ip_address_t));

			note_construction("ip_spec: TOKEN_ANY\n");
			note_ip_address_list(node);

			(yyval) = (YYSTYPE) (void*) node;
		}
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 412 "parser.y"
    {
			note_construction("ip_spec: TOKEN_NEGATE ip_spec\n");
			note_progress("negation\n");
			note_ip_address_list((list_node_t*) (yyvsp[(2) - (2)]));

			uNegation = !uNegation;
			(yyval) = (YYSTYPE) (yyvsp[(2) - (2)]);
		}
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 423 "parser.y"
    {
			note_construction("ip_set: ip_address\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (1)]));

			(yyval) = (YYSTYPE) (yyvsp[(1) - (1)]);
		}
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 430 "parser.y"
    {
			list_node_t* node = (list_node_t*) (yyvsp[(1) - (3)]);
			list_node_t* set = (list_node_t*) (yyvsp[(3) - (3)]);

			note_construction("ip_set: ip_address TOKEN_COMMA ip_set\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (3)]));
			note_ip_address_list((list_node_t*) (yyvsp[(3) - (3)]));

			node->next = set;

			(yyval) = (YYSTYPE) (void*) node;
		}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 445 "parser.y"
    {
			ip_address_t* address = (ip_address_t*) malloc(sizeof(ip_address_t));
			list_node_t* node = new_list_node(address, NULL);
			const char* name = get_token_string();

			note_construction("ip_address: TOKEN_HOSTNAME\n");

			memset(address, 0, sizeof(ip_address_t));
			address->ip4_addr = inet_addr(name);
			address->mask = 0xffffffff;

			note_ip_address_list(node);

			free((char*) name);
			(yyval) = (YYSTYPE) (void*) node;
		}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 462 "parser.y"
    {
			note_construction("ip_address: network\n");
			note_ip_address_list((list_node_t*) (yyvsp[(1) - (1)]));

			(yyval) = (YYSTYPE) (yyvsp[(1) - (1)]);
		}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 471 "parser.y"
    {
			ip_address_t* address = (ip_address_t*) malloc(sizeof(ip_address_t));
			list_node_t* node = new_list_node(address, NULL);
			const char* name = get_token_string();
			int network_bits = get_token_number();

			note_construction("network: TOKEN_HOSTNAME TOKEN_FORWARD_SLASH TOKEN_NUMBER\n");
			note_progress(name);
			note_progress("\n");
			note_number(network_bits);

			memset(address, 0, sizeof(ip_address_t));
			address->ip4_addr = inet_addr(name);
			address->mask = 0;

			if (network_bits)
			{
				int index;
				int zero_bits = 32 - network_bits;

				for (index = 0; index < 32; index++)
				{
					if (index >= zero_bits)
					{
						address->mask |= (1 << index);
					}
				}
			}

			/* IP addresses are stored in network byte order, so in order to bitwise AND them we
			 * store masks in network byte order too.
			 */
			address->mask = htonl(address->mask);

			note_ip_address_list(node);

			free((char*) name);
			(yyval) = (YYSTYPE) (void*) node;
		}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 513 "parser.y"
    {
			ipf_port_t* port = new_port();
		
			note_construction("definite_port_spec: single_port\n");

			port->first = htons((int) (yyvsp[(1) - (1)]));
			port->last = htons((int) (yyvsp[(1) - (1)]));

			note_port(port);

			(yyval) = (YYSTYPE) (void*) port;
		}
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 526 "parser.y"
    {
			note_construction("definite_port_spec: port_range\n");
			(yyval) = (YYSTYPE) (yyvsp[(1) - (1)]);
		}
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 533 "parser.y"
    {
			variable_t* port_var = get_port_variable((const char*) (yyvsp[(2) - (2)]));

			note_construction("port_spec: TOKEN_DOLLAR variable\n");
			note_progress((const char*) (yyvsp[(2) - (2)]));
			note_progress("\n");

			if (port_var)
			{
				ipf_port_t* port = new_port();
				
				memcpy(port, &port_var->ports, sizeof(ipf_port_t));
				
				(yyval) = (YYSTYPE) (void*) port;
			}
			else
			{
				fprintf(stderr, "error: could not find port variable: %s\n", (const char*) (yyvsp[(2) - (2)]));
				exit(EXIT_FAILURE);
			}

			free((char*) (yyvsp[(2) - (2)]));
		}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 557 "parser.y"
    {
			note_construction("port_spec: definite_port_spec\n");
			note_port((ipf_port_t*) (yyvsp[(1) - (1)]));
			
			(yyval) = (YYSTYPE) (yyvsp[(1) - (1)]);
		}
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 564 "parser.y"
    {
			ipf_port_t* port = new_port();
		
			note_construction("port_spec: TOKEN_ANY\n");

			port->any = 1;

			note_port(port);

			(yyval) = (YYSTYPE) (void*) port;
		}
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 576 "parser.y"
    {
			note_construction("port_spec: TOKEN_NEGATE port_spec\n");

			((ipf_port_t*) (yyvsp[(2) - (2)]))->inverse = !((ipf_port_t*) (yyvsp[(2) - (2)]))->inverse;

			note_port((ipf_port_t*) (yyvsp[(2) - (2)]));

			(yyval) = (YYSTYPE) (void*) (yyvsp[(2) - (2)]);
		}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 588 "parser.y"
    {
			ipf_port_t* port = new_port();
		
			note_construction("port_range: single_port TOKEN_COLON single_port\n");

			port->first = htons((int) (yyvsp[(1) - (3)]));
			port->last = htons((int) (yyvsp[(3) - (3)]));

			note_port(port);

			(yyval) = (YYSTYPE) (void*) port;
		}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 601 "parser.y"
    {
			ipf_port_t* port = new_port();
		
			note_construction("port_range: TOKEN_COLON single_port\n");
		
			port->last = htons((int) (yyvsp[(2) - (2)]));

			note_port(port);

			(yyval) = (YYSTYPE) (void*) port;
		}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 613 "parser.y"
    {
			ipf_port_t* port = new_port();
		
			note_construction("port_range: single_port TOKEN_COLON\n");
		
			port->first = htons((int) (yyvsp[(1) - (2)]));

			note_port(port);

			(yyval) = (YYSTYPE) (void*) port;
		}
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 627 "parser.y"
    { 
			note_construction("single_port: TOKEN_NUMBER\n");
			(yyval) = (YYSTYPE) get_token_number(); 
			note_number(get_token_number());
		}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 635 "parser.y"
    { 
			note_construction("variable: TOKEN_VARIABLE\n");
			(yyval) = (YYSTYPE) (void*) get_token_string(); 
			note_progress((const char*) (yyval));
			note_progress("\n");
		}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 645 "parser.y"
    { 
			note_construction("body: TOKEN_BODY\n");
			(yyval) = (YYSTYPE) NULL;
			note_progress((const char*) (yyval));
			note_progress("\n");
		}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 652 "parser.y"
    {
			(yyval) = (YYSTYPE) NULL;
		}
    break;



/* Line 1806 of yacc.c  */
#line 2248 "parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 657 "parser.y"


void
yyerror(const char* error_msg)
{
	fprintf(stderr, "yyerror(): %s\n", error_msg);
}


void
note_construction(const char* comment)
{
#if VERBOSE
	if (uLogfile)
	{
		fprintf(uLogfile, "\n");
		fprintf(uLogfile, "%s", comment);
	}
#endif /* VERBOSE */
}


void
note_progress(const char* comment)
{
#if VERBOSE
	if (uLogfile)
	{
		fprintf(uLogfile, "%s", comment);
	}
#endif /* VERBOSE */
}


void
note_rule(filter_rule_t* rule)
{
#if VERBOSE
	if (uLogfile)
	{
		display_rule(uLogfile, rule);
		fprintf(uLogfile, "\n");
	}
#endif /* VERBOSE */
}


void
note_port(ipf_port_t* port)
{
#if VERBOSE
	if (uLogfile)
	{
		display_port(uLogfile, port);
		fprintf(uLogfile, "\n");
	}
#endif /* VERBOSE */
}


void
note_ip_address(ip_address_t* address)
{
#if VERBOSE
	if (uLogfile)
	{
		display_ip_address(uLogfile, address);
		fprintf(uLogfile, "\n");
	}
#endif /* VERBOSE */
}


void
note_ip_address_list(list_node_t* node)
{
#if VERBOSE
	if (uLogfile)
	{
		display_ip_address_list(uLogfile, node);
		fprintf(uLogfile, "\n");
	}
#endif /* VERBOSE */
}


void
note_number(int number)
{
#if VERBOSE
	if (uLogfile)
	{
		fprintf(uLogfile, "%d\n", number);
	}
#endif /* VERBOSE */
}


filter_rule_t*
parse_single_line(const char* line, FILE* logfile)
{
	filter_rule_t* result = NULL;

	/* Reset variables. */
	uLogfile = logfile;
	uAction = 0;
	uProtocol = 0;
	uBidirectional = 0;
	uSourceAddress = NULL;
	uSourceNegated = 0;
	uSourcePort = NULL;
	uDestinationAddress = NULL;
	uDestinationNegated = 0;
	uDestinationPort = NULL;
	uNegation = 0;

	yy_scan_string(line);
	yyparse();

	result = uRule;
	uRule = NULL;

	return result;
}

